#
# scpkt6.rb
#
# $Id: scpkt6.rb,v 1.1 2000/11/21 03:02:06 keiko Exp $
#

require "narray"
require "numru/dcl"

include NumRu::DCL
include Math


NX = 37
NY = 37
XMIN = 0
XMAX = 360
YMIN = 0
YMAX = 180

alon = NArray.sfloat( NX)
alat = NArray.sfloat( NY)
p = NArray.sfloat( NX, NY)
xp = NArray.sfloat( 3)
yp = NArray.sfloat( 3)
zp = NArray.sfloat( 3)

#-- data ---
alon.indgen(XMIN, (XMAX-XMIN)/(NX-1).to_f)
alat.indgen(YMIN, (YMAX-YMIN)/(NY-1).to_f)
p.fill!(1.0)

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i

sgopn iws

sgfrm
sglset('LDEG', true)

#---------------- 3-D ------------------
scsorg(1.0, 0.0, 0.0, 0.0)
scstrn(3)
scstrf

scseye(-5.0, -3.0, 2.0)
scsobj(0.0, 0.0, 0.0)
scsprj

scspli(1)
scstnp(2999, 4999)

(NY-2).downto(0) do |j|
  (NX-2).downto(0) do |i|
    xp[0] = alon[i]
    yp[0] = alat[j]
    zp[0] = p[i,j]
    xp[1] = alon[i]
    yp[1] = alat[j+1]
    zp[1] = p[i,j+1]
    xp[2] = alon[i+1]
    yp[2] = alat[j+1]
    zp[2] = p[i+1,j+1]

    sctnu(zp, yp, xp)
    scplu(3, zp, yp, xp)

    xp[0] = alon[i+1]
    yp[0] = alat[j+1]
    zp[0] = p[i+1,j+1]
    xp[1] = alon[i+1]
    yp[1] = alat[j]
    zp[1] = p[i+1,j]
    xp[2] = alon[i]
    yp[2] = alat[j]
    zp[2] = p[i,j]

    sctnu(zp, yp, xp)
    scplu(3, zp, yp, xp)
  end
end

sgcls

